#ifndef AVIDIALOG_H
#define AVIDIALOG_H


struct DisplayModeDescription
{
	int w, h, d;
	CString desc;
};

typedef CArray<DisplayModeDescription, DisplayModeDescription> DisplayModeArray;

/////////////////////////////////////////////////////////////////////////////
// AviDialog dialog

class AviDialog : public CDialog
{
// Construction
public:
	AviDialog(CWnd* pParent = NULL);   // standard constructor
	BOOL InitControls();
	int GetIndex()   { return index; }
	void SetArray( DisplayModeArray* );
	BOOL FilePalettized()  { return filepalettized; }
	BOOL GetAviSpecs(LPCTSTR filename, int* w, int* h=0, int* d=0, int* f=0);
// Dialog Data
	//{{AFX_DATA(AviDialog)
	enum { IDD = IDD_AVIDIALOG };
	CListBox	modelist;
	CString	filename;
	CString	pathname;
	CString	avidims;
	CString	aviframes;
	//}}AFX_DATA
	CString fullfilename;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(AviDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(AviDialog)
	afx_msg void OnOpenAvi();
	afx_msg void OnSelchangeModelist();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	DisplayModeArray* displaymodelist;
	int filepalettized;
	int index;
};

#endif