#ifndef AVIPLAYWIN_H
#define AVIPLAYWIN_H


#include "DirectDrawWin.h"
#include "AviDialog.h"


class AviPlayWin : public DirectDrawWin
{
public:
	AviPlayWin();
protected:
	//{{AFX_MSG(AviPlayWin)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int SelectInitialDisplayMode();
	BOOL CreateCustomSurfaces() { return TRUE; }
	void DrawScene();
	void RestoreSurfaces();
	void GetSystemPalette();
	void ShowDialog();
	BOOL LoadAvi();
	BOOL CreateAviSurface();
	BOOL UpdateAviSurface();
	BOOL InstallPalette();
private:
	AviDialog* avidialog;

	CString fullfilename;
	CString filename;
	CString pathname;

	CRect displayrect;
	LPDIRECTDRAWSURFACE avisurf;
	CRect avirect;
	int x,y;
	DisplayModeArray displaymode;	

	LPDIRECTDRAWPALETTE syspal;
	LPDIRECTDRAWPALETTE avipal;

	PAVISTREAM avistream;
	AVISTREAMINFO streaminfo;
	HIC decomp;
	long fmtlen, buflen;
	long startframe, endframe;
	long curframe;
	LPBITMAPINFOHEADER srcfmt;
	LPBITMAPINFOHEADER dstfmt;
	BYTE* rawdata;
	BYTE* finaldata;
};


#endif
