#ifndef BMPDIALOG_H
#define BMPDIALOG_H


struct DisplayModeDescription
{
	int w, h, d;
	CString desc;
};

typedef CArray<DisplayModeDescription, DisplayModeDescription> DisplayModeArray;

/////////////////////////////////////////////////////////////////////////////
// BmpDialog dialog

class BmpDialog : public CDialog
{
// Construction
public:
	BmpDialog(CWnd* pParent = NULL);   // standard constructor
	BOOL InitControls();
	int GetIndex()   { return index; }
	void SetArrays( DisplayModeArray*, DisplayModeArray*);
	BOOL FilePalettized()  { return filepalettized; }
	BOOL BmpDialog::GetBmpDimensions( LPCTSTR filename, int* w, int* h=0, int* d=0);
// Dialog Data
	//{{AFX_DATA(BmpDialog)
	enum { IDD = IDD_BMPDIALOG };
	CListBox	modelist;
	CString	filename;
	CString	pathname;
	CString	bmpspecs;
	//}}AFX_DATA
	CString fullfilename;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(BmpDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(BmpDialog)
	afx_msg void OnOpenbmp();
	afx_msg void OnSelchangeModelist();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	DisplayModeArray* palettized;
	DisplayModeArray* nonpalettized;
	int filepalettized;
	int index;
};

#endif