#ifndef BMPVIEWWIN_H
#define BMPVIEWWIN_H


#include "DirectDrawWin.h"
#include "BmpDialog.h"


class BmpViewWin : public DirectDrawWin
{
public:
	BmpViewWin();
protected:
	//{{AFX_MSG(BmpViewWin)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int SelectInitialDisplayMode();
	BOOL CreateCustomSurfaces() { return TRUE; }
	void DrawScene();
	void RestoreSurfaces();
	void GetSystemPalette();
	void ShowDialog();
	BOOL LoadBmp();
	void PageUp();
	void PageDown();
	void Home();
	void End();
	void Left(int inc=4);
	void Right(int inc=4);
	void Up(int inc=4);
	void Down(int inc=4);
private:
	BmpDialog* bmpdialog;
	LPDIRECTDRAWPALETTE syspal;

	CString fullfilename;
	CString filename;
	CString pathname;

	CRect displayrect;
	LPDIRECTDRAWSURFACE bmpsurf;
	CRect bmprect;
	int x,y;
	int xscroll, yscroll;
	int xlimit, ylimit;
	BOOL update_screen;
	DisplayModeArray palettemode, nonpalettemode;	
};


#endif
