#include "Headers.h"
#include "Sprite.h"


Sprite::Sprite(LPDIRECTDRAWSURFACE s, int xx, int yy)
{
	DDSURFACEDESC desc;
	ZeroMemory( &desc, sizeof(desc) );
	desc.dwSize=sizeof(desc);
	desc.dwFlags=DDSD_WIDTH | DDSD_HEIGHT;
	s->GetSurfaceDesc( &desc );

	surf=s;
	x=xx;
	y=yy;
	w=desc.dwWidth;
	h=desc.dwHeight;

	collide=FALSE;

	CalcVector();
}

void Sprite::CalcVector()
{
	xinc=(rand()%7)-3;
	yinc=(rand()%7)-3;
}

CRect Sprite::GetRect()
{
	CRect r;
	r.left=x;
	r.top=y;
	r.right=x+w;
	r.bottom=y+h;
	return r;
}

void Sprite::Update()
{
	if (collide)
	{
		int centerx=GetCenterX();
		int centery=GetCenterY();
		int xvect=collideinfo.x-centerx;
		int yvect=collideinfo.y-centery;
		if ((xinc>0 && xvect>0) || (xinc<0 && xvect<0))
			xinc=-xinc;
		if ((yinc>0 && yvect>0) || (yinc<0 && yvect<0))
			yinc=-yinc;
		collide=FALSE;
	}

	x+=xinc;
	y+=yinc;

	if (x>640-w/2)
	{
		xinc=-xinc;
		x=640-w/2;
	}
	if (x<-(w/2))
	{
		xinc=-xinc;
		x=-(w/2);
	}
	if (y>480-h/2)
	{
		yinc=-yinc;
		y=480-h/2;
	}
	if (y<-(h/2))
	{
		yinc=-yinc;
		y=-(h/2);
	}
}

void Sprite::Hit(Sprite* s)
{
	if (!collide)
	{
		collideinfo.x=s->GetCenterX();
		collideinfo.y=s->GetCenterY();
		collide=TRUE;
	}
}