#ifndef CURSORWIN_H
#define CURSORWIN_H


#include "DirectDrawWin.h"

const int mouse_event_index = 0;
const int quit_event_index = 1;

const int coil_frames=15;


struct MouseClickData
{
	int x, y;
	int button;
};

class CursorWin : public DirectDrawWin
{
public:
	CursorWin();
protected:
	//{{AFX_MSG(CursorWin)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int SelectDriver();
	int SelectInitialDisplayMode();
	BOOL CreateCustomSurfaces();
	void DrawScene();
	void RestoreSurfaces();
private:
	BOOL InitMouse();
	BOOL InitKeyboard();
	BOOL UpdateDelaySurface();
private:
	//------- mouse thread functions ------
	static DWORD MouseThread(LPVOID);
	BOOL UpdateCursorSimpleCase(int curx, int cury, int oldcurx, int oldcury);
	BOOL UpdateCursorComplexCase(int curx, int cury, int oldcurx, int oldcury);
private:
	//------- mouse stuff -------
 	static LPDIRECTINPUTDEVICE mouse;

	static CCriticalSection critsection;
	static CWinThread* mousethread;
	static CEvent* mouse_event[2];

	static int cursor_width;
	static int cursor_height;
	static LPDIRECTDRAWSURFACE cursor;
	static LPDIRECTDRAWSURFACE cursor_under;
	static LPDIRECTDRAWSURFACE cursor_union;

	static int curx, cury;
	static int oldcurx, oldcury;
	static CList<MouseClickData, MouseClickData> mouseclickqueue;
private:
	//------- app stuff -------
	LPDIRECTINPUT dinput;
	LPDIRECTINPUTDEVICE keyboard;

	LPDIRECTDRAWSURFACE coil[coil_frames];

	LPDIRECTDRAWSURFACE dm_surf;
	int dm_index;

	DWORD menubarfillcolor;
	HFONT largefont, smallfont;
};


#endif
