#include "Headers.h"
#include "resource.h"
#include "DriverDialog.h"
#include "QwertyWin.h"

#pragma comment (lib,"ddraw.lib")
#pragma comment (lib,"dinput.lib")
#pragma comment (lib,"dxguid.lib")


BEGIN_MESSAGE_MAP(QwertyWin, DirectDrawWin)
	//{{AFX_MSG_MAP(QwertyWin)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ACTIVATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


QwertyWin::QwertyWin()
{
	dinput=0;
	keyboard=0;
	esc_pressed=FALSE;
}

BOOL QwertyWin::CreateCustomSurfaces()
{
	if (GetCurDisplayDepth()==8)
	{
		esc_up=CreateSurface( "escape_up_08.bmp", TRUE );
		esc_dn=CreateSurface( "escape_dn_08.bmp" );

		space_up=CreateSurface( "space_up_08.bmp" );
		space_dn=CreateSurface( "space_dn_08.bmp" );

		q_up=CreateSurface( "q_up_08.bmp" );
		q_dn=CreateSurface( "q_dn_08.bmp" );

		w_up=CreateSurface( "w_up_08.bmp" );
		w_dn=CreateSurface( "w_dn_08.bmp" );

		e_up=CreateSurface( "e_up_08.bmp" );
		e_dn=CreateSurface( "e_dn_08.bmp" );

		r_up=CreateSurface( "r_up_08.bmp" );
		r_dn=CreateSurface( "r_dn_08.bmp" );

		t_up=CreateSurface( "t_up_08.bmp" );
		t_dn=CreateSurface( "t_dn_08.bmp" );

		y_up=CreateSurface( "y_up_08.bmp" );
		y_dn=CreateSurface( "y_dn_08.bmp" );

		lctrl_up=CreateSurface( "lctrl_up_08.bmp" );
		lctrl_dn=CreateSurface( "lctrl_dn_08.bmp" );

		rctrl_up=CreateSurface( "rctrl_up_08.bmp" );
		rctrl_dn=CreateSurface( "rctrl_dn_08.bmp" );

		lalt_up=CreateSurface( "lalt_up_08.bmp" );
		lalt_dn=CreateSurface( "lalt_dn_08.bmp" );

		ralt_up=CreateSurface( "ralt_up_08.bmp" );
		ralt_dn=CreateSurface( "ralt_dn_08.bmp" );
	}
	else
	{
		esc_up=CreateSurface( "escape_up_24.bmp" );
		esc_dn=CreateSurface( "escape_dn_24.bmp" );

		space_up=CreateSurface( "space_up_24.bmp" );
		space_dn=CreateSurface( "space_dn_24.bmp" );

		q_up=CreateSurface( "q_up_24.bmp" );
		q_dn=CreateSurface( "q_dn_24.bmp" );

		w_up=CreateSurface( "w_up_24.bmp" );
		w_dn=CreateSurface( "w_dn_24.bmp" );

		e_up=CreateSurface( "e_up_24.bmp" );
		e_dn=CreateSurface( "e_dn_24.bmp" );

		r_up=CreateSurface( "r_up_24.bmp" );
		r_dn=CreateSurface( "r_dn_24.bmp" );

		t_up=CreateSurface( "t_up_24.bmp" );
		t_dn=CreateSurface( "t_dn_24.bmp" );

		y_up=CreateSurface( "y_up_24.bmp" );
		y_dn=CreateSurface( "y_dn_24.bmp" );

		lctrl_up=CreateSurface( "lctrl_up_24.bmp" );
		lctrl_dn=CreateSurface( "lctrl_dn_24.bmp" );

		rctrl_up=CreateSurface( "rctrl_up_24.bmp" );
		rctrl_dn=CreateSurface( "rctrl_dn_24.bmp" );

		lalt_up=CreateSurface( "lalt_up_24.bmp" );
		lalt_dn=CreateSurface( "lalt_dn_24.bmp" );

		ralt_up=CreateSurface( "ralt_up_24.bmp" );
		ralt_dn=CreateSurface( "ralt_dn_24.bmp" );
	}

	ClearSurface( backsurf, 0 );
	ClearSurface( primsurf, 0 );

	return TRUE;
}

void QwertyWin::DrawScene()
{
	static char key[256];
	keyboard->GetDeviceState( sizeof(key), &key );

	//---------- QWERTY keys --------
	if ( key[DIK_Q] & 0x80 )
		BltSurface( backsurf, q_dn, 213, 70 );
	else
		BltSurface( backsurf, q_up, 213, 70 );

	if ( key[DIK_W] & 0x80 )
		BltSurface( backsurf, w_dn, 251, 70 );
	else
		BltSurface( backsurf, w_up, 251, 70 );

	if ( key[DIK_E] & 0x80 )
		BltSurface( backsurf, e_dn, 298, 70 );
	else
		BltSurface( backsurf, e_up, 298, 70 );

	if ( key[DIK_R] & 0x80 )
		BltSurface( backsurf, r_dn, 328, 70 );
	else
		BltSurface( backsurf, r_up, 328, 70 );

	if ( key[DIK_T] & 0x80 )
		BltSurface( backsurf, t_dn, 361, 70 );
	else
		BltSurface( backsurf, t_up, 361, 70 );

	if ( key[DIK_Y] & 0x80 )
		BltSurface( backsurf, y_dn, 393, 70 );
	else
		BltSurface( backsurf, y_up, 393, 70 );

	//---------------- LEFT CONTROL ---------------
	if ( key[DIK_LCONTROL] & 0x80 )
		BltSurface( backsurf, lctrl_dn, 50, 180 );
	else
		BltSurface( backsurf, lctrl_up, 49, 180 );

	//---------------- RIGHT CONTROL ---------------
	if ( key[DIK_RCONTROL] & 0x80 )
		BltSurface( backsurf, rctrl_dn, 490, 180 );
	else
		BltSurface( backsurf, rctrl_up, 490, 180 );

	//---------------- LEFT ALT ---------------
	if ( key[DIK_LMENU] & 0x80 )
		BltSurface( backsurf, lalt_dn, 100, 260 );
	else
		BltSurface( backsurf, lalt_up, 100, 260 );

	//---------------- RIGHT ALT ---------------
	if ( key[DIK_RMENU] & 0x80 )
		BltSurface( backsurf, ralt_dn, 440, 260 );
	else
		BltSurface( backsurf, ralt_up, 440, 260 );

	//---------------- SPACE -----------------
	if ( key[DIK_SPACE] & 0x80 )
		BltSurface( backsurf, space_dn, 170, 340 );
	else
		BltSurface( backsurf, space_up, 170, 340 );
	
	//---------- ESCAPE -------------
	if ( key[DIK_ESCAPE] & 0x80 )
	{
		BltSurface( backsurf, esc_dn, 0, 0 );
		esc_pressed=TRUE;
	}
	else
	{
		BltSurface( backsurf, esc_up, 0, 0 );
		if (esc_pressed)
			PostMessage( WM_CLOSE );
	}

	primsurf->Flip( 0, DDFLIP_WAIT );
}

void QwertyWin::RestoreSurfaces()
{
	if (GetCurDisplayDepth()==8)
	{
		esc_up->Restore();
		LoadSurface( esc_up, "escape_up_08.bmp" );
		esc_dn->Restore();
		LoadSurface( esc_dn, "escape_dn_08.bmp" );

		space_up->Restore();
		LoadSurface( space_up, "space_up_08.bmp" );
		space_dn->Restore();
		LoadSurface( space_dn, "space_dn_08.bmp" );

		q_up->Restore();
		LoadSurface( q_up, "q_up_08.bmp" );
		q_dn->Restore();
		LoadSurface( q_dn, "q_dn_08.bmp" );

		w_up->Restore();
		LoadSurface( w_up, "w_up_08.bmp" );
		w_dn->Restore();
		LoadSurface( w_dn, "w_dn_08.bmp" );

		e_up->Restore();
		LoadSurface( e_up, "e_up_08.bmp" );
		e_dn->Restore();
		LoadSurface( e_dn, "e_dn_08.bmp" );

		r_up->Restore();
		LoadSurface( r_up, "r_up_08.bmp" );
		r_dn->Restore();
		LoadSurface( r_dn, "r_dn_08.bmp" );

		t_up->Restore();
		LoadSurface( t_up, "t_up_08.bmp" );
		t_dn->Restore();
		LoadSurface( t_dn, "t_dn_08.bmp" );

		y_up->Restore();
		LoadSurface( y_up, "y_up_08.bmp" );
		y_dn->Restore();
		LoadSurface( y_dn, "y_dn_08.bmp" );

		lctrl_up->Restore();
		LoadSurface( lctrl_up, "lctrl_up_08.bmp" );
		lctrl_dn->Restore();
		LoadSurface( lctrl_dn, "lctrl_dn_08.bmp" );

		rctrl_up->Restore();
		LoadSurface( rctrl_up, "rctrl_up_08.bmp" );
		rctrl_dn->Restore();
		LoadSurface( rctrl_dn, "rctrl_dn_08.bmp" );

		lalt_up->Restore();
		LoadSurface( lalt_up, "lalt_up_08.bmp" );
		lalt_dn->Restore();
		LoadSurface( lalt_dn, "lalt_dn_08.bmp" );

		ralt_up->Restore();
		LoadSurface( ralt_up, "ralt_up_08.bmp" );
		ralt_dn->Restore();
		LoadSurface( ralt_dn, "ralt_dn_08.bmp" );
	}
	else
	{
		esc_up->Restore();
		LoadSurface( esc_up, "escape_up_24.bmp" );
		esc_dn->Restore();
		LoadSurface( esc_dn, "escape_dn_24.bmp" );

		space_up->Restore();
		LoadSurface( space_up, "space_up_24.bmp" );
		space_dn->Restore();
		LoadSurface( space_dn, "space_dn_24.bmp" );

		q_up->Restore();
		LoadSurface( q_up, "q_up_24.bmp" );
		q_dn->Restore();
		LoadSurface( q_dn, "q_dn_24.bmp" );

		w_up->Restore();
		LoadSurface( w_up, "w_up_24.bmp" );
		w_dn->Restore();
		LoadSurface( w_dn, "w_dn_24.bmp" );

		e_up->Restore();
		LoadSurface( e_up, "e_up_24.bmp" );
		e_dn->Restore();
		LoadSurface( e_dn, "e_dn_24.bmp" );

		r_up->Restore();
		LoadSurface( r_up, "r_up_24.bmp" );
		r_dn->Restore();
		LoadSurface( r_dn, "r_dn_24.bmp" );

		t_up->Restore();
		LoadSurface( t_up, "t_up_24.bmp" );
		t_dn->Restore();
		LoadSurface( t_dn, "t_dn_24.bmp" );

		y_up->Restore();
		LoadSurface( y_up, "y_up_24.bmp" );
		y_dn->Restore();
		LoadSurface( y_dn, "y_dn_24.bmp" );

		lctrl_up->Restore();
		LoadSurface( lctrl_up, "lctrl_up_24.bmp" );
		lctrl_dn->Restore();
		LoadSurface( lctrl_dn, "lctrl_dn_24.bmp" );

		rctrl_up->Restore();
		LoadSurface( rctrl_up, "rctrl_up_24.bmp" );
		rctrl_dn->Restore();
		LoadSurface( rctrl_dn, "rctrl_dn_24.bmp" );

		lalt_up->Restore();
		LoadSurface( lalt_up, "lalt_up_24.bmp" );
		lalt_dn->Restore();
		LoadSurface( lalt_dn, "lalt_dn_24.bmp" );

		ralt_up->Restore();
		LoadSurface( ralt_up, "ralt_up_24.bmp" );
		ralt_dn->Restore();
		LoadSurface( ralt_dn, "ralt_dn_24.bmp" );
	}

	ClearSurface( backsurf, 0 );
	ClearSurface( primsurf, 0 );
}

int QwertyWin::SelectDriver()
{
	int numdrivers=GetNumDrivers();
	if (numdrivers==1)
		return 0;

	CArray<CString, CString> drivers;
	for (int i=0;i<numdrivers;i++)
	{
		LPSTR desc, name;
		GetDriverInfo( i, 0, &desc, &name );
		drivers.Add(desc);
	}

	DriverDialog dialog;
	dialog.SetContents( &drivers );
	if (dialog.DoModal()!=IDOK)
		return -1;

	return dialog.GetSelection();
}

int QwertyWin::SelectInitialDisplayMode()
{
	DWORD curdepth=GetDisplayDepth();
	int i, nummodes=GetNumDisplayModes();
	DWORD w,h,d;

	//----- look for 640x480 with current pixel depth
	for (i=0;i<nummodes;i++)
	{
		GetDisplayModeDimensions( i, w, h, d );
		if (w==640 && h==480 && d==curdepth)
			return i;
	}

	//----- barring that, try anything with the current depth
	for (i=0;i<nummodes;i++)
	{
		GetDisplayModeDimensions( i, w, h, d );
		if (d==curdepth)
			return i;
	}

	//----- if that fails, try finding any 640x480 mode
	for (i=0;i<nummodes;i++)
	{
		GetDisplayModeDimensions( i, w, h, d );
		if (w==640 && h==480)
			return i;
	}

	return 0;
}

int QwertyWin::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	HRESULT r=DirectInputCreate( AfxGetInstanceHandle(), 
			DIRECTINPUT_VERSION, &dinput, 0 ); 
	if (r!=DI_OK)
	{
		AfxMessageBox("DirectInputCreate() failed");
		return -1;
	}

	r = dinput->CreateDevice( GUID_SysKeyboard, &keyboard, 0 ); 
	if (r!=DI_OK)
	{
		AfxMessageBox("CreateDevice(keyboard) failed");	
		return -1;
	}

	r = keyboard->SetDataFormat( &c_dfDIKeyboard );
	if (r!=DI_OK)
	{
		AfxMessageBox("keyboard->SetDataFormat() failed");
		return -1;
	}

	r=keyboard->SetCooperativeLevel( GetSafeHwnd(), 
			DISCL_FOREGROUND | DISCL_NONEXCLUSIVE); 
	if (r!=DI_OK)
	{
		AfxMessageBox("keyboard->SetCooperativeLevel() failed");
		return -1;
	}

	if (DirectDrawWin::OnCreate(lpCreateStruct)==-1)
		return -1;

	return 0;
}

void QwertyWin::OnDestroy() 
{
	DirectDrawWin::OnDestroy();
	
	if (dinput)
		dinput->Release(), dinput=0;
	if (keyboard)
	{
		keyboard->Unacquire();
		keyboard->Release(), keyboard=0;
	}
}

void QwertyWin::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	DirectDrawWin::OnActivate(nState, pWndOther, bMinimized);
	
	if (nState!=WA_INACTIVE && keyboard)
	{
		TRACE("keyboard->Acquire()\n");
		keyboard->Acquire();
	}
}
